Index: sys/kern/kern_resource.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_resource.c,v
retrieving revision 1.69
diff -u -r1.69 kern_resource.c
--- sys/kern/kern_resource.c	2000/12/13 00:17:01	1.69
+++ sys/kern/kern_resource.c	2000/12/13 05:40:23
@@ -89,6 +89,7 @@
 {
 	register struct proc *p;
 	register int low = PRIO_MAX + 1;
+	int privused = 0, cumulative_privused = 0;
 
 	switch (uap->which) {
 
@@ -112,8 +113,11 @@
 		else if ((pg = pgfind(uap->who)) == NULL)
 			break;
 		LIST_FOREACH(p, &pg->pg_members, p_pglist) {
-			if (!p_can(curp, p, P_CAN_SEE, NULL) && p->p_nice < low)
+			if (!p_can(curp, p, P_CAN_SEE, &privused) &&
+			    p->p_nice < low)
 				low = p->p_nice;
+			if (privused)
+				cumulative_privused = 1;
 		}
 		break;
 	}
@@ -123,10 +127,13 @@
 			uap->who = curp->p_ucred->cr_uid;
 		ALLPROC_LOCK(AP_SHARED);
 		LIST_FOREACH(p, &allproc, p_list)
-			if (!p_can(curp, p, P_CAN_SEE, NULL) &&
+			if (!p_can(curp, p, P_CAN_SEE, NULL)  &&
 			    p->p_ucred->cr_uid == uap->who &&
-			    p->p_nice < low)
+			    p->p_nice < low) {
 				low = p->p_nice;
+				if (privused)
+					cumulative_privused = 1;
+			}
 		ALLPROC_LOCK(AP_RELEASE);
 		break;
 
@@ -135,6 +142,10 @@
 	}
 	if (low == PRIO_MAX + 1)
 		return (ESRCH);
+
+	if (cumulative_privused)
+		suser_used(curp);
+
 	curp->p_retval[0] = low;
 	return (0);
 }
@@ -220,8 +231,11 @@
 		n = PRIO_MAX;
 	if (n < PRIO_MIN)
 		n = PRIO_MIN;
-	if (n < chgp->p_nice && suser(curp))
-		return (EACCES);
+	if (n < chgp->p_nice) {
+		if ((error = cap_check(NULL, curp, CAP_SYS_NICE, 0)) != 0)
+			return (error);
+		suser_used(curp);
+	}
 	chgp->p_nice = n;
 	(void)resetpriority(chgp);
 	return (0);
@@ -269,7 +283,7 @@
 		if ((error = p_can(curp, p, P_CAN_SCHED, NULL)))
 		        return (error);
 		/* disallow setting rtprio in most cases if not superuser */
-		if (suser(curp) != 0) {
+		if (cap_check(NULL, curp, CAP_SYS_NICE, 0)) {
 			/* can't set someone else's */
 			if (uap->pid)
 				return (EPERM);
@@ -287,6 +301,7 @@
 			if (rtp.type != RTP_PRIO_NORMAL)
 				return (EPERM);
 		}
+		suser_used(curp);
 		switch (rtp.type) {
 #ifdef RTP_PRIO_FIFO
 		case RTP_PRIO_FIFO:
@@ -401,9 +416,12 @@
 		limp->rlim_max = RLIM_INFINITY;
 
 	if (limp->rlim_cur > alimp->rlim_max ||
-	    limp->rlim_max > alimp->rlim_max)
-		if ((error = suser_xxx(0, p, PRISON_ROOT)))
+	    limp->rlim_max > alimp->rlim_max) {
+		if ((error = cap_check(0, p, CAP_SYS_NICE, PRISON_ROOT))
+		    != 0)
 			return (error);
+		suser_used(p);
+	}
 	if (limp->rlim_cur > limp->rlim_max)
 		limp->rlim_cur = limp->rlim_max;
 	if (p->p_limit->p_refcnt > 1 &&
Index: sys/kern/kern_shutdown.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_shutdown.c,v
retrieving revision 1.90
diff -u -r1.90 kern_shutdown.c
--- sys/kern/kern_shutdown.c	2000/12/15 20:08:19	1.90
+++ sys/kern/kern_shutdown.c	2001/01/05 17:01:04
@@ -139,8 +139,9 @@
 {
 	int error;
 
-	if ((error = suser(p)))
+	if ((error = cap_check(NULL, p, CAP_SYS_BOOT, 0)) != 0)
 		return (error);
+	suser_used(p);
 
 	boot(uap->opt);
 	return (0);
Index: sys/kern/kern_sig.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_sig.c,v
retrieving revision 1.101
diff -u -r1.101 kern_sig.c
--- sys/kern/kern_sig.c	2001/01/02 18:54:09	1.101
+++ sys/kern/kern_sig.c	2001/01/05 17:01:05
@@ -65,6 +65,7 @@
 #include <sys/sysent.h>
 #include <sys/sysctl.h>
 #include <sys/malloc.h>
+#include <sys/capability.h>
 
 #include <machine/cpu.h>
 #include <machine/smp.h>
@@ -96,6 +97,11 @@
 
 /*
  * Can process p, with pcred pc, send the signal sig to process q?
+ * XXX should p be able to signal q outside the same prison if CAP_KILL
+ * is present?
+ *
+ * XXX This should propagate the privused flag up the stack but
+ * doesn't.
  */
 #define CANSIGNAL(p, q, sig) \
 	(!p_can(p, q, P_CAN_KILL, NULL) || \
Index: sys/kern/kern_sysctl.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_sysctl.c,v
retrieving revision 1.102
diff -u -r1.102 kern_sysctl.c
--- sys/kern/kern_sysctl.c	2001/01/05 07:00:44	1.102
+++ sys/kern/kern_sysctl.c	2001/01/05 17:01:05
@@ -1015,11 +1015,22 @@
 		return (EPERM);
 
 	/* Most likely only root can write */
+	/*
+	 * XXX What about capabilities?
+	 * Ought to have another argument to SYSCTL_* allowing a specific
+	 * capability to be identified as providing the privilege to write,
+	 * rather than just suser().  For now, use CAP_SYSADMIN, but this
+	 * should change.
+	 */
 	if (!(oid->oid_kind & CTLFLAG_ANYBODY) &&
-	    req->newptr && req->p &&
-	    (error = suser_xxx(0, req->p, 
-	    (oid->oid_kind & CTLFLAG_PRISON) ? PRISON_ROOT : 0)))
-		return (error);
+	    req->newptr && req->p) {
+		int flag_prison = ((oid->oid_kind & CTLFLAG_PRISON) ?
+		    PRISON_ROOT : 0);
+		if ((error = cap_check(0, req->p, CAP_SYS_ADMIN,
+		    flag_prison)) != 0)
+			return (error);
+		suser_used(req->p);
+	}
 
 	if (!oid->oid_handler)
 		return EINVAL;
Index: sys/kern/kern_time.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_time.c,v
retrieving revision 1.71
diff -u -r1.71 kern_time.c
--- sys/kern/kern_time.c	2000/11/27 22:52:29	1.71
+++ sys/kern/kern_time.c	2000/12/13 05:37:22
@@ -174,8 +174,9 @@
 	struct timespec ats;
 	int error;
 
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_SYS_TIME, 0)) != 0)
 		return (error);
+	suser_used(p);
 	if (SCARG(uap, clock_id) != CLOCK_REALTIME)
 		return (EINVAL);
 	if ((error = copyin(SCARG(uap, tp), &ats, sizeof(ats))) != 0)
@@ -331,8 +332,9 @@
 	struct timezone atz;
 	int error;
 
-	if ((error = suser(p)))
+	if ((error = cap_check(NULL, p, CAP_SYS_TIME, 0)) != 0)
 		return (error);
+	suser_used(p);
 	/* Verify all parameters before changing time. */
 	if (uap->tv) {
 		if ((error = copyin((caddr_t)uap->tv, (caddr_t)&atv,
@@ -371,8 +373,10 @@
 	register long ndelta, ntickdelta, odelta;
 	int s, error;
 
-	if ((error = suser(p)))
+	if ((error = cap_check(NULL, p, CAP_SYS_TIME, 0)) != 0)
 		return (error);
+	suser_used(p);
+
 	if ((error =
 	    copyin((caddr_t)uap->delta, (caddr_t)&atv, sizeof(struct timeval))))
 		return (error);
Index: sys/kern/kern_xxx.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_xxx.c,v
retrieving revision 1.31
diff -u -r1.31 kern_xxx.c
--- sys/kern/kern_xxx.c	1999/08/28 00:46:15	1.31
+++ sys/kern/kern_xxx.c	2000/09/17 14:56:07
@@ -85,8 +85,10 @@
 
 	name[0] = CTL_KERN;
 	name[1] = KERN_HOSTNAME;
-	if ((error = suser_xxx(0, p, PRISON_ROOT)))
+	if ((error = cap_check(0, p, CAP_SYS_ADMIN, PRISON_ROOT)) != 0)
 		return (error);
+	suser_used(p);
+
 	return (userland_sysctl(p, name, 2, 0, 0, 0,
 		uap->hostname, uap->len, 0));
 }
@@ -122,8 +124,10 @@
 {
 	int error;
 
-	if ((error = suser(p)))
+	if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
 		return (error);
+	suser_used(p);
+
 	hostid = uap->hostid;
 	return (0);
 }
@@ -244,8 +248,10 @@
 {
         int error, domainnamelen;
 
-        if ((error = suser(p)))
+        if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
                 return (error);
+	suser_used(p);
+
         if ((u_int)uap->len > sizeof (domainname) - 1)
                 return EINVAL;
         domainnamelen = uap->len;
Index: sys/kern/makesyscalls.sh
===================================================================
RCS file: /home/ncvs/src/sys/kern/makesyscalls.sh,v
retrieving revision 1.44
diff -u -r1.44 makesyscalls.sh
--- sys/kern/makesyscalls.sh	2000/12/01 08:47:54	1.44
+++ sys/kern/makesyscalls.sh	2000/12/13 05:37:22
@@ -111,8 +111,9 @@
 		printf " * created from%s\n */\n\n", $0 > sysarg
 		printf "#ifndef %s\n", sysproto_h > sysarg
 		printf "#define\t%s\n\n", sysproto_h > sysarg
-		printf "#include <sys/signal.h>\n\n" > sysarg
-		printf "#include <sys/acl.h>\n\n" > sysarg
+		printf "#include <sys/signal.h>\n" > sysarg
+		printf "#include <sys/acl.h>\n" > sysarg
+		printf "#include <sys/capability.h>\n\n" > sysarg
 		printf "struct proc;\n\n" > sysarg
 		printf "#define\tPAD_(t)\t(sizeof(register_t) <= sizeof(t) ? \\\n" > sysarg
 		printf "\t\t0 : sizeof(register_t) - sizeof(t))\n\n" > sysarg
Index: sys/kern/sys_process.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/sys_process.c,v
retrieving revision 1.59
diff -u -r1.59 sys_process.c
--- sys/kern/sys_process.c	2000/12/31 01:30:27	1.59
+++ sys/kern/sys_process.c	2001/01/05 17:01:06
@@ -206,6 +206,7 @@
 	struct proc *p;
 	struct iovec iov;
 	struct uio uio;
+	int privused = 0;
 	int error = 0;
 	int write;
 	int s;
@@ -237,8 +238,10 @@
 		if (p->p_flag & P_TRACED)
 			return EBUSY;
 
-		if ((error = p_can(curp, p, P_CAN_DEBUG, NULL)))
+		if ((error = p_can(curp, p, P_CAN_DEBUG, &privused)))
 			return error;
+		if (privused)
+			suser_used(curp);
 
 		/* OK */
 		break;
Index: sys/kern/sys_socket.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/sys_socket.c,v
retrieving revision 1.32
diff -u -r1.32 sys_socket.c
--- sys/kern/sys_socket.c	2000/07/03 00:05:40	1.32
+++ sys/kern/sys_socket.c	2000/08/07 18:44:28
@@ -45,6 +45,7 @@
 #include <sys/stat.h>
 #include <sys/uio.h>
 #include <sys/filedesc.h>
+#include <sys/capability.h>
 #include <sys/ucred.h>
 
 #include <net/if.h>
Index: sys/kern/sysv_ipc.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/sysv_ipc.c,v
retrieving revision 1.17
diff -u -r1.17 sysv_ipc.c
--- sys/kern/sysv_ipc.c	2000/12/01 08:57:45	1.17
+++ sys/kern/sysv_ipc.c	2000/12/14 00:42:39
@@ -92,8 +92,13 @@
 
 	/* Check for user match. */
 	if (cred->cr_uid != perm->cuid && cred->cr_uid != perm->uid) {
-		if (mode & IPC_M)
-			return (suser(p) == 0 ? 0 : EPERM);
+		if (mode & IPC_M) {
+			if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
+				return (error);
+		else {
+			suser_used(p);
+			return (0);
+		}
 		/* Check for group match. */
 		mode >>= 3;
 		if (!groupmember(perm->gid, cred) &&
@@ -104,5 +109,13 @@
 
 	if (mode & IPC_M)
 		return (0);
-	return ((mode & perm->mode) == mode || suser(p) == 0 ? 0 : EACCES);
+
+	if ((mode & perm->mode) == mode)
+		return (0);
+
+	if (cap_check(NULL, p, CAP_IPC_OWNER, 0) == 0) {
+		suser_user(p);
+		return (0);
+	}
+	return (EACCES);
 }
Index: sys/kern/sysv_msg.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/sysv_msg.c,v
retrieving revision 1.28
diff -u -r1.28 sysv_msg.c
--- sys/kern/sysv_msg.c	2000/12/05 23:05:45	1.28
+++ sys/kern/sysv_msg.c	2000/12/13 05:37:24
@@ -402,9 +402,10 @@
 		if ((eval = copyin(user_msqptr, &msqbuf, sizeof(msqbuf))) != 0)
 			return(eval);
 		if (msqbuf.msg_qbytes > msqptr->msg_qbytes) {
-			eval = suser(p);
-			if (eval)
+			eval = cap_check(NULL, p, CAP_SYS_RESOURCE, 0);
+			if (eval != 0)
 				return(eval);
+			suser_used(p);
 		}
 		if (msqbuf.msg_qbytes > msginfo.msgmnb) {
 #ifdef MSG_DEBUG_OK
Index: sys/kern/tty.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/tty.c,v
retrieving revision 1.142
diff -u -r1.142 tty.c
--- sys/kern/tty.c	2000/12/08 21:50:36	1.142
+++ sys/kern/tty.c	2000/12/13 05:37:24
@@ -816,8 +816,10 @@
 			    ISSET(constty->t_state, TS_CONNECTED))
 				return (EBUSY);
 #ifndef	UCONSOLE
-			if ((error = suser(p)) != 0)
+			if ((error = cap_check(NULL, p, CAP_SYS_TTY_CONFIG,
+			    0)) != 0)
 				return (error);
+			suser_used(p);
 #endif
 			constty = tp;
 		} else if (tp == constty)
@@ -988,10 +990,19 @@
 		splx(s);
 		break;
 	case TIOCSTI:			/* simulate terminal input */
-		if ((flag & FREAD) == 0 && suser(p))
-			return (EPERM);
-		if (!isctty(p, tp) && suser(p))
-			return (EACCES);
+		if ((flag & FREAD) == 0) {
+			if ((error = cap_check(NULL, p, CAP_SYS_TTY_CONFIG,
+			    0)) != 0)
+				return (error);
+			else
+				suser_used(p);
+		}
+		if (!isctty(p, tp)) {
+			if (cap_check(NULL, p, CAP_SYS_TTY_CONFIG, 0) != 0)
+				return (EACCES);
+			else
+				suser_used(p);
+		}
 		s = spltty();
 		(*linesw[tp->t_line].l_rint)(*(u_char *)data, tp);
 		splx(s);
@@ -1038,9 +1049,10 @@
 		}
 		break;
 	case TIOCSDRAINWAIT:
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_SYS_TTY_CONFIG, 0)) != 0)
 			return (error);
+		suser_used(p);
+
 		tp->t_timeout = *(int *)data * hz;
 		wakeup(TSA_OCOMPLETE(tp));
 		wakeup(TSA_OLOWAT(tp));
Index: sys/kern/tty_cons.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/tty_cons.c,v
retrieving revision 1.88
diff -u -r1.88 tty_cons.c
--- sys/kern/tty_cons.c	2000/12/20 21:50:37	1.88
+++ sys/kern/tty_cons.c	2001/01/05 17:01:06
@@ -374,9 +374,10 @@
 	 * output from the "virtual" console.
 	 */
 	if (cmd == TIOCCONS && constty) {
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_SYS_TTY_CONFIG, 0)) != 0)
 			return (error);
+		suser_used(p);
+
 		constty = NULL;
 		return (0);
 	}
Index: sys/kern/tty_pty.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/tty_pty.c,v
retrieving revision 1.82
diff -u -r1.82 tty_pty.c
--- sys/kern/tty_pty.c	2000/12/08 21:50:37	1.82
+++ sys/kern/tty_pty.c	2000/12/13 05:37:25
@@ -183,7 +183,11 @@
 		tp->t_lflag = TTYDEF_LFLAG;
 		tp->t_cflag = TTYDEF_CFLAG;
 		tp->t_ispeed = tp->t_ospeed = TTYDEF_SPEED;
-	} else if (tp->t_state & TS_XCLUDE && suser(p)) {
+	} else if (tp->t_state & TS_XCLUDE) {
+		/*
+		 * XXX used to be && suser(p) with, why could suser override
+		 * TS_XCLUDE?
+		 */
 		return (EBUSY);
 	} else if (pti->pt_prison != p->p_prison) {
 		return (EBUSY);
Index: sys/kern/tty_snoop.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/tty_snoop.c,v
retrieving revision 1.50
diff -u -r1.50 tty_snoop.c
--- sys/kern/tty_snoop.c	2000/12/08 21:50:37	1.50
+++ sys/kern/tty_snoop.c	2000/12/13 05:37:25
@@ -285,7 +285,7 @@
 	struct snoop   *snp;
 	int error;
 
-	if ((error = suser(p)) != 0)
+	if (((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
 		return (error);
 
 	if (dev->si_drv1 == NULL) {
Index: sys/kern/vfs_subr.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_subr.c,v
retrieving revision 1.298
diff -u -r1.298 vfs_subr.c
--- sys/kern/vfs_subr.c	2000/12/15 20:08:19	1.298
+++ sys/kern/vfs_subr.c	2001/01/05 17:01:07
@@ -3032,15 +3032,12 @@
 	int *privused;
 {
 	mode_t dac_granted;
-#ifdef CAPABILITIES
 	mode_t cap_granted;
-#endif
 
 	/*
 	 * Look for a normal, non-privileged way to access the file/directory
 	 * as requested.  If it exists, go with that.
 	 */
-
 	if (privused != NULL)
 		*privused = 0;
 
@@ -3088,14 +3085,6 @@
 		return (0);
 
 privcheck:
-	if (!suser_xxx(cred, NULL, PRISON_ROOT)) {
-		/* XXX audit: privilege used */
-		if (privused != NULL)
-			*privused = 1;
-		return (0);
-	}
-
-#ifdef CAPABILITIES
 	/*
 	 * Build a capability mask to determine if the set of capabilities
 	 * satisfies the requirements when combined with the granted mask
@@ -3104,16 +3093,27 @@
 	 * or the request type onto the cap_granted mask.
 	 */
 	cap_granted = 0;
-	if ((acc_mode & VEXEC) && ((dac_granted & VEXEC) == 0) &&
-	    !cap_check_xxx(cred, NULL, CAP_DAC_EXECUTE, PRISON_ROOT))
-	    cap_granted |= VEXEC;
+
+	if (type == VDIR) {
+		/*
+		 * For directories, use CAP_DAC_READ_SEARCH to satisfy
+		 * VEXEC requests, instead of CAP_DAC_EXECUTE.
+		 */
+		if ((acc_mode & VEXEC) && ((dac_granted & VEXEC) == 0) &&
+		    !cap_check(cred, NULL, CAP_DAC_READ_SEARCH, PRISON_ROOT))
+			cap_granted |= VEXEC;
+	} else {
+		if ((acc_mode & VEXEC) && ((dac_granted & VEXEC) == 0) &&
+		    !cap_check(cred, NULL, CAP_DAC_EXECUTE, PRISON_ROOT))
+			cap_granted |= VEXEC;
+	}
 
 	if ((acc_mode & VREAD) && ((dac_granted & VREAD) == 0) &&
-	    !cap_check_xxx(cred, NULL, CAP_DAC_READ_SEARCH, PRISON_ROOT))
+	    !cap_check(cred, NULL, CAP_DAC_READ_SEARCH, PRISON_ROOT))
 		cap_granted |= VREAD;
 
 	if ((acc_mode & VWRITE) && ((dac_granted & VWRITE) == 0) &&
-	    !cap_check_xxx(cred, NULL, CAP_DAC_WRITE, PRISON_ROOT))
+	    !cap_check(cred, NULL, CAP_DAC_WRITE, PRISON_ROOT))
 		cap_granted |= VWRITE;
 
 	if ((acc_mode & VADMIN) && ((dac_granted & VADMIN) == 0) &&
@@ -3126,7 +3126,6 @@
 			*privused = 1;
 		return (0);
 	}
-#endif
 
 	return (EACCES);
 }
Index: sys/kern/vfs_syscalls.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_syscalls.c,v
retrieving revision 1.175
diff -u -r1.175 vfs_syscalls.c
--- sys/kern/vfs_syscalls.c	2000/12/13 00:17:01	1.175
+++ sys/kern/vfs_syscalls.c	2000/12/13 05:37:27
@@ -122,21 +122,28 @@
 	struct nameidata nd;
 	char fstypename[MFSNAMELEN];
 
-	if (usermount == 0 && (error = suser(p)))
-		return (error);
+	if (usermount == 0) {
+		if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
+			return (error);
+		suser_used(p);
+	}
 	/*
 	 * Do not allow NFS export by non-root users.
 	 */
 	if (SCARG(uap, flags) & MNT_EXPORTED) {
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
 			return (error);
+		suser_used(p);
 	}
 	/*
 	 * Silently enforce MNT_NOSUID and MNT_NODEV for non-root users
 	 */
-	if (suser_xxx(p->p_ucred, 0, 0)) 
+	if (cap_check(p->p_ucred, NULL, CAP_SYS_ADMIN, 0) != 0)
 		SCARG(uap, flags) |= MNT_NOSUID | MNT_NODEV;
+	else if ((SCARG(uap, flags) & (MNT_NOSUID | MNT_NODEV)) !=
+	    (MNT_NOSUID | MNT_NODEV))
+		suser_used(p);
+	
 	/*
 	 * Get vnode to be covered
 	 */
@@ -168,10 +175,11 @@
 		 * permitted to update it.
 		 */
 		if (mp->mnt_stat.f_owner != p->p_ucred->cr_uid &&
-		    (error = suser(p))) {
+		    ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)) {
 			vput(vp);
 			return (error);
-		}
+		} else
+			suser_used(p);
 		if (vfs_busy(mp, LK_NOWAIT, 0, p)) {
 			vput(vp);
 			return (EBUSY);
@@ -196,10 +204,13 @@
 	 * onto which we are attempting to mount.
 	 */
 	if ((error = VOP_GETATTR(vp, &va, p->p_ucred, p)) ||
-	    (va.va_uid != p->p_ucred->cr_uid &&
-	     (error = suser(p)))) {
-		vput(vp);
-		return (error);
+	    (va.va_uid != p->p_ucred->cr_uid)) {
+		if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
+			suser_used(p);
+		else {
+			vput(vp);
+			return (error);
+		}
 	}
 	if ((error = vinvalbuf(vp, V_SAVE, p->p_ucred, p, 0, 0)) != 0) {
 		vput(vp);
@@ -220,10 +231,11 @@
 		linker_file_t lf;
 
 		/* Only load modules for root (very important!) */
-		if ((error = suser(p)) != 0) {
+		if ((error = cap_check(NULL, p, CAP_SYS_MODULE, 0)) != 0) {
 			vput(vp);
 			return error;
 		}
+		suser_used(p);
 		error = linker_load_file(fstypename, &lf);
 		if (error || lf == NULL) {
 			vput(vp);
@@ -426,10 +438,12 @@
 	 * Only root, or the user that did the original mount is
 	 * permitted to unmount this filesystem.
 	 */
-	if ((mp->mnt_stat.f_owner != p->p_ucred->cr_uid) &&
-	    (error = suser(p))) {
-		vput(vp);
-		return (error);
+	if ((mp->mnt_stat.f_owner != p->p_ucred->cr_uid)) {
+		if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0) {
+			vput(vp);
+			return (error);
+		}
+		suser_used(p);
 	}
 
 	/*
@@ -652,11 +666,12 @@
 	if (error)
 		return (error);
 	sp->f_flags = mp->mnt_flag & MNT_VISFLAGMASK;
-	if (suser_xxx(p->p_ucred, 0, 0)) {
+	if (cap_check(p->p_ucred, NULL, CAP_SYS_ADMIN, 0) != 0) {
 		bcopy((caddr_t)sp, (caddr_t)&sb, sizeof(sb));
 		sb.f_fsid.val[0] = sb.f_fsid.val[1] = 0;
 		sp = &sb;
-	}
+	} else
+		suser_used(p);
 	return (copyout((caddr_t)sp, (caddr_t)SCARG(uap, buf), sizeof(*sp)));
 }
 
@@ -692,11 +707,12 @@
 	if (error)
 		return (error);
 	sp->f_flags = mp->mnt_flag & MNT_VISFLAGMASK;
-	if (suser_xxx(p->p_ucred, 0, 0)) {
+	if (cap_check(p->p_ucred, NULL, CAP_SYS_ADMIN, 0) != 0) {
 		bcopy((caddr_t)sp, (caddr_t)&sb, sizeof(sb));
 		sb.f_fsid.val[0] = sb.f_fsid.val[1] = 0;
 		sp = &sb;
-	}
+	} else
+		suser_used(p);
 	return (copyout((caddr_t)sp, (caddr_t)SCARG(uap, buf), sizeof(*sp)));
 }
 
@@ -908,9 +924,10 @@
 	int error;
 	struct nameidata nd;
 
-	error = suser_xxx(0, p, PRISON_ROOT);
-	if (error)
+	if ((error = cap_check(NULL, p, CAP_SYS_CHROOT, PRISON_ROOT)) != 0)
 		return (error);
+	suser_used(p);
+
 	if (chroot_allow_open_directories == 0 ||
 	    (chroot_allow_open_directories == 1 && fdp->fd_rdir != rootvnode))
 		error = chroot_refuse_vdir_fds(fdp);
@@ -1170,10 +1187,10 @@
 	switch (SCARG(uap, mode) & S_IFMT) {
 	case S_IFCHR:
 	case S_IFBLK:
-		error = suser(p);
+		error = cap_check(NULL, p, CAP_MKNOD, 0);
 		break;
 	default:
-		error = suser_xxx(0, p, PRISON_ROOT);
+		error = cap_check(NULL, p, CAP_MKNOD, PRISON_ROOT);
 		break;
 	}
 	if (error)
@@ -2052,9 +2069,12 @@
 	 * if they are allowed to set flags and programs assume that
 	 * chown can't fail when done as root.
 	 */
-	if ((vp->v_type == VCHR || vp->v_type == VBLK) && 
-	    ((error = suser_xxx(p->p_ucred, p, PRISON_ROOT)) != 0))
-		return (error);
+	if (vp->v_type == VCHR || vp->v_type == VBLK) {
+		if ((error = cap_check(p->p_ucred, p, CAP_SYS_SETFFLAG,
+		    PRISON_ROOT)) != 0)
+			return (error);
+		suser_used(p);
+	}
 
 	if ((error = vn_start_write(vp, &mp, V_WAIT | PCATCH)) != 0)
 		return (error);
@@ -3244,8 +3264,12 @@
 	}
 	if ((error = VOP_GETATTR(vp, &vattr, p->p_ucred, p)) != 0)
 		goto out;
-	if (p->p_ucred->cr_uid != vattr.va_uid &&
-	    (error = suser_xxx(0, p, PRISON_ROOT)))
+	if (p->p_ucred->cr_uid != vattr.va_uid) {
+		if ((error = cap_check(NULL, p, CAP_SYS_ADMIN,
+		    PRISON_ROOT)) != 0)
+			goto out;
+		suser_used(p);
+	}
 		goto out;
 	if ((error = vn_start_write(vp, &mp, V_WAIT | PCATCH)) != 0)
 		goto out;
@@ -3298,9 +3322,10 @@
 	/*
 	 * Must be super user
 	 */
-	error = suser(p);
-	if (error)
+	if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
 		return (error);
+	suser_used(p);
+
 	NDINIT(&nd, LOOKUP, FOLLOW | LOCKLEAF, UIO_USERSPACE, uap->fname, p);
 	error = namei(&nd);
 	if (error)
@@ -3353,9 +3378,9 @@
 	/*
 	 * Must be super user
 	 */
-	error = suser(p);
-	if (error)
+	if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
 		return (error);
+	suser_used(p);
 
 	fmode = FFLAGS(SCARG(uap, flags));
 	/* why not allow a non-read/write open for our lockd? */
@@ -3523,9 +3548,9 @@
 	/*
 	 * Must be super user
 	 */
-	error = suser(p);
-	if (error)
+	if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
 		return (error);
+	suser_used(p);
 	
 	error = copyin(SCARG(uap, u_fhp), &fh, sizeof(fhandle_t));
 	if (error)
@@ -3570,8 +3595,9 @@
 	/*
 	 * Must be super user
 	 */
-	if ((error = suser(p)))
+	if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
 		return (error);
+	suser_used(p);
 
 	if ((error = copyin(SCARG(uap, u_fhp), &fh, sizeof(fhandle_t))) != 0)
 		return (error);
@@ -3586,11 +3612,13 @@
 	if ((error = VFS_STATFS(mp, sp, p)) != 0)
 		return (error);
 	sp->f_flags = mp->mnt_flag & MNT_VISFLAGMASK;
-	if (suser_xxx(p->p_ucred, 0, 0)) {
+	if (cap_check(p->p_ucred, NULL, CAP_SYS_ADMIN, 0) != 0) {
 		bcopy((caddr_t)sp, (caddr_t)&sb, sizeof(sb));
 		sb.f_fsid.val[0] = sb.f_fsid.val[1] = 0;
 		sp = &sb;
-	}
+	} else
+		suser_used(p);
+
 	return (copyout(sp, SCARG(uap, buf), sizeof(*sp)));
 }
 
Index: sys/kern/vfs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_vnops.c,v
retrieving revision 1.106
diff -u -r1.106 vfs_vnops.c
--- sys/kern/vfs_vnops.c	2000/11/18 23:06:23	1.106
+++ sys/kern/vfs_vnops.c	2000/12/13 05:37:27
@@ -531,7 +531,7 @@
 	}
 	
 	sb->st_flags = vap->va_flags;
-	if (suser_xxx(p->p_ucred, 0, 0))
+	if (cap_check(p->p_ucred, NULL, CAP_SYS_ADMIN, 0) != 0)
 		sb->st_gen = 0;
 	else
 		sb->st_gen = vap->va_gen;
Index: sys/miscfs/procfs/procfs_mem.c
===================================================================
RCS file: /home/ncvs/src/sys/miscfs/procfs/procfs_mem.c,v
retrieving revision 1.47
diff -u -r1.47 procfs_mem.c
--- sys/miscfs/procfs/procfs_mem.c	2000/08/30 04:49:08	1.47
+++ sys/miscfs/procfs/procfs_mem.c	2000/09/17 15:32:38
@@ -304,7 +304,10 @@
 	struct ucred *cred;
 
 	cred = curp->p_ucred;
-	if (suser(curp))
+	/*
+	 * XXX is CAP_SYS_ADMIN appropriate here?  If not, what?
+	 */
+	if (cap_check(NULL, curp, CAP_SYS_ADMIN, 0))
 		return 1;
 
 	/* XXX: Why isn't this done with file-perms ??? */
Index: sys/miscfs/procfs/procfs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/miscfs/procfs/procfs_vnops.c,v
retrieving revision 1.87
diff -u -r1.87 procfs_vnops.c
--- sys/miscfs/procfs/procfs_vnops.c	2000/12/31 10:24:19	1.87
+++ sys/miscfs/procfs/procfs_vnops.c	2001/01/05 17:41:26
@@ -248,7 +248,8 @@
 	   */
 #define NFLAGS	(PF_ISUGID)
 	  flags = (unsigned char)*(unsigned int*)ap->a_data;
-	  if (flags & NFLAGS && (error = suser(p)))
+	  if (flags & NFLAGS && (error = cap_check(NULL, p, CAP_SYS_PTRACE,
+	    0)))
 	    return error;
 	  procp->p_pfsflags = flags;
 	  break;
Index: sys/miscfs/umapfs/umap_vfsops.c
===================================================================
RCS file: /home/ncvs/src/sys/miscfs/umapfs/umap_vfsops.c,v
retrieving revision 1.33
diff -u -r1.33 umap_vfsops.c
--- sys/miscfs/umapfs/umap_vfsops.c	2000/10/29 16:06:36	1.33
+++ sys/miscfs/umapfs/umap_vfsops.c	2000/11/07 02:43:13
@@ -100,8 +100,9 @@
 
 	/*
 	 * Only for root
+	 * XXX: Is CAP_SYS_ADMIN appropriate?
 	 */
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
 		return (error);
 
 #ifdef DEBUG
Index: sys/msdosfs/msdosfs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/msdosfs/msdosfs_vnops.c,v
retrieving revision 1.106
diff -u -r1.106 msdosfs_vnops.c
--- sys/msdosfs/msdosfs_vnops.c	2000/10/22 14:24:30	1.106
+++ sys/msdosfs/msdosfs_vnops.c	2000/10/23 06:52:29
@@ -391,7 +391,8 @@
 		if (vp->v_mount->mnt_flag & MNT_RDONLY)
 			return (EROFS);
 		if (cred->cr_uid != pmp->pm_uid &&
-		    (error = suser_xxx(cred, ap->a_p, PRISON_ROOT)))
+		    (error =
+		    cap_check(cred, ap->a_p, CAP_FOWNER, PRISON_ROOT)))
 			return (error);
 		/*
 		 * We are very inconsistent about handling unsupported
Index: sys/net/if.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if.c,v
retrieving revision 1.96
diff -u -r1.96 if.c
--- sys/net/if.c	2000/12/08 21:50:43	1.96
+++ sys/net/if.c	2000/12/13 05:38:16
@@ -769,7 +769,7 @@
 	register struct ifnet *ifp;
 	register struct ifreq *ifr;
 	struct ifstat *ifs;
-	int error;
+	int error, privilege_used = 0;
 	short oif_flags;
 
 	switch (cmd) {
@@ -801,9 +801,10 @@
 		break;
 
 	case SIOCSIFFLAGS:
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 			return (error);
+		suser_used(p);
+
 		ifr->ifr_prevflags = ifp->if_flags;
 		if (ifp->if_flags & IFF_SMART) {
 			/* Smart drivers twiddle their own routes */
@@ -826,31 +827,37 @@
 		break;
 
 	case SIOCSIFMETRIC:
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 			return (error);
+		suser_used(p);
+
 		ifp->if_metric = ifr->ifr_metric;
 		getmicrotime(&ifp->if_lastchange);
 		break;
 
 	case SIOCSIFPHYS:
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 			return error;
+		privilege_used = 1;
+
 		if (!ifp->if_ioctl)
 		        return EOPNOTSUPP;
 		error = (*ifp->if_ioctl)(ifp, cmd, data);
 		if (error == 0)
 			getmicrotime(&ifp->if_lastchange);
+
+		if (error == 0 && privilege_used)
+			suser_used(p);
 		return(error);
 
 	case SIOCSIFMTU:
 	{
 		u_long oldmtu = ifp->if_mtu;
 
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 			return (error);
+		privilege_used = 1;
+
 		if (ifp->if_ioctl == NULL)
 			return (EOPNOTSUPP);
 		if (ifr->ifr_mtu < IF_MINMTU || ifr->ifr_mtu > IF_MAXMTU)
@@ -868,14 +875,16 @@
 			nd6_setmtu(ifp);
 #endif
 		}
+		if (error == 0 && privilege_used)
+			suser_used(p);
 		return (error);
 	}
 
 	case SIOCADDMULTI:
 	case SIOCDELMULTI:
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 			return (error);
+		privilege_used = 1;
 
 		/* Don't allow group membership on non-multicast interfaces. */
 		if ((ifp->if_flags & IFF_MULTICAST) == 0)
@@ -893,6 +902,8 @@
 		}
 		if (error == 0)
 			getmicrotime(&ifp->if_lastchange);
+		if (error == 0 && privilege_used)
+			suser_used(p);
 		return error;
 
 	case SIOCSIFPHYADDR:
@@ -902,14 +913,17 @@
 #endif
         case SIOCSIFMEDIA:
 	case SIOCSIFGENERIC:
-		error = suser(p);
-		if (error)
+		if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 			return (error);
+		privilege_used = 1;
+
 		if (ifp->if_ioctl == 0)
 			return (EOPNOTSUPP);
 		error = (*ifp->if_ioctl)(ifp, cmd, data);
 		if (error == 0)
 			getmicrotime(&ifp->if_lastchange);
+		if (error == 0 && privilege_used)
+			suser_used(p);
 		return error;
 
 	case SIOCGIFSTATUS:
@@ -923,7 +937,7 @@
 		return ((*ifp->if_ioctl)(ifp, cmd, data));
 
 	case SIOCSIFLLADDR:
-		error = suser(p);
+		error = cap_check(NULL, p, CAP_NET_ADMIN, 0);
 		if (error)
 			return (error);
 		return if_setlladdr(ifp,
Index: sys/net/if_ppp.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_ppp.c,v
retrieving revision 1.68
diff -u -r1.68 if_ppp.c
--- sys/net/if_ppp.c	2000/11/25 07:35:31	1.68
+++ sys/net/if_ppp.c	2000/12/13 05:43:39
@@ -355,8 +355,10 @@
 	break;
 
     case PPPIOCSFLAGS:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    break;
+	    return (error);
+	suser_used(p);
 	flags = *(int *)data & SC_MASK;
 	s = splsoftnet();
 #ifdef PPP_COMPRESS
@@ -369,8 +371,9 @@
 	break;
 
     case PPPIOCSMRU:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    return (error);
+	suser_used(p);
 	mru = *(int *)data;
 	if (mru >= PPP_MRU && mru <= PPP_MAXMRU)
 	    sc->sc_mru = mru;
@@ -382,8 +385,9 @@
 
 #ifdef VJC
     case PPPIOCSMAXCID:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    break;
+	suser_used(p);
 	if (sc->sc_comp) {
 	    s = splsoftnet();
 	    sl_compress_init(sc->sc_comp, *(int *)data);
@@ -393,15 +397,17 @@
 #endif
 
     case PPPIOCXFERUNIT:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    break;
+	suser_used(p);
 	sc->sc_xfer = p->p_pid;
 	break;
 
 #ifdef PPP_COMPRESS
     case PPPIOCSCOMPRESS:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    break;
+	suser_used(p);
 	odp = (struct ppp_option_data *) data;
 	nb = odp->length;
 	if (nb > sizeof(ccp_option))
@@ -475,8 +481,10 @@
 	if (cmd == PPPIOCGNPMODE) {
 	    npi->mode = sc->sc_npmode[npx];
 	} else {
-	    if ((error = suser(p)) != 0)
+	    if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 		break;
+		return (error);
+	    suser_used(p);
 	    if (npi->mode != sc->sc_npmode[npx]) {
 		s = splsoftnet();
 		sc->sc_npmode[npx] = npi->mode;
@@ -601,8 +609,9 @@
 	break;
 
     case SIOCSIFMTU:
-	if ((error = suser(p)) != 0)
+	if ((error = cap_check(NULL, p, CAP_NET_ADMIN, 0)) != 0)
 	    break;
+	suser_used(p);
 	if (ifr->ifr_mtu > PPP_MAXMTU)
 	    error = EINVAL;
 	else {
